(* 45678901234567890123456789012345678901234567890123456789012345678901234567 *)

Lemma strong_induction:
  forall (P : nat -> Prop),
    P 0 ->
      (forall k, (forall j, j <= k -> P j) -> P (S k)) ->
      forall n, P n.
Proof.
  Lemma helper:
    forall (P : nat -> Prop),
      P 0 ->
        (forall k, (forall j, j <= k -> P j) -> P (S k)) ->
        forall n, forall m, m <= n -> P m.
  Proof.
    induction n ; intros ; inversion H1 ; eauto.
  Qed.

  intros.
  apply helper with (n := n) ; eauto.
Qed.

Tactic Notation "strong" "induction" ident(n) :=
  induction n using strong_induction.
